I8259_0 EQU 200H	
I8259_1 EQU 201H	

I8255_A EQU 210H	;A˿
I8255_B EQU 211H	;B˿
I8255_C EQU 212H	;C˿
I8255_CTR EQU 213H	

I8254_0 EQU 220H	;0ʽ3
I8254_1 EQU 221H	;1ʽ2
I8254_2 EQU 222H	;2ʽ3
I8254_CTR EQU 223H

I0809_CS EQU 230H
led_io		equ	240h
DATA SEGMENT PAGE
	speed DW 1
    s8 DW 11111111B	;LED
	s7 DW 11111110B
	s6 DW 11111100B
	s5 DW 11111000B
	s4 DW 11110000B
	s3 DW 11100000B
	s2 DW 11000000B
	s1 DW 10000000B
	ledcode db 71h, 79h, 5eh, 39h, 7ch, 77h, 67h, 7fh, 07h, 7dh, 6dh, 66h, 4fh, 5bh, 06h, 3fh	;ܱ
	led1	db	01h	;־λ

DATA ENDS

STACK SEGMENT PAGE
	STK DW 100 DUP(0)
STACK ENDS

CODE SEGMENT PAGE
	ASSUME CS:CODE,DS:DATA,SS:STACK
START:	
	CLI;رж
	MOV AX,DATA
	MOV DS,AX
	
	MOV AX,STK
	MOV SS,AX;

	MOV DX,I8259_0;****************************ʼ8259A
	MOV AL,00010011B ;ICW1
	OUT DX,AL
	MOV DX,I8259_1
	MOV AL,00001000B ;ICW2IR0жΪ08H
	OUT DX,AL
	MOV AL,00000001B ;ICW4
	OUT DX,AL

	PUSH DS;***********************************INT_procж    
	XOR AX,AX
	MOV DS,AX
	LEA AX,CS:INT_PROC
	MOV SI,08H
	ADD SI,SI
	ADD SI,SI
	MOV DS:[SI],AX ;IP
	PUSH CS
	POP AX
	MOV DS:[SI+2],AX ;CS
	POP DS

	PUSH DS;***********************************INT_PROC1ж     
	XOR AX,AX
	MOV DS,AX
	LEA AX,CS:INT_PROC1
	MOV SI,0AH
	ADD SI,SI
	ADD SI,SI
	MOV DS:[SI],AX ;IP
	PUSH CS
	POP AX
	MOV DS:[SI+2],AX ;CS
	POP DS
	
	IN AL,DX;OCW1
	AND AL,11111000B
	OUT DX,AL

	MOV DX,I8255_CTR ;**************************8255ʼ
	MOV AL,10000010B ;A/Cڷʽ0Bڷʽ1룬Ϊ10000010B
	OUT DX,AL;д     
	
	MOV DX,I8254_CTR ;8254ʼ  
	MOV AL,00110110B ;0ʽ3Ƽ
	OUT DX,AL
	MOV DX,I8254_0
	MOV AX,5000 ;дֵ5000ڷƵ
	OUT DX,AL
	XCHG AL,AH
	OUT DX,AL
	MOV DX,I8254_CTR
	MOV AL,01110100B ;1Ϊʽ2
	OUT DX,AL
	MOV DX,I8254_1
	MOV AX,2 ;?ͨıźƵʸıٶȣдʼٶ
	OUT DX,AL
	XCHG AL,AH
	OUT DX,AL

	MOV DX,I8254_CTR
	MOV AL,10110110B ;ü2Ϊʽ3жÿ0.05sһж
	OUT DX,AL
	MOV DX,I8254_2
	MOV AX,10;
	OUT DX,AL
	XCHG AL,AH
	OUT DX,AL

	MOV DX,I0809_CS 
	OUT DX,AL;ADת 
	STI ; ж
;***********************ѭ *******************
LOP:
	MOV AX,speed
	CMP AX, 1
    JE  speed8
    CMP AX, 2
    JE  speed7
    CMP AX, 3
    JE  speed6
    CMP AX, 4
    JE  speed5
    CMP AX, 5
    JE  speed4
    CMP AX, 6
    JE  speed3
    CMP AX, 7
    JE  speed2
    CMP AX, 8
    JE  speed1
;·֧ǽתLEDƥ
speed1:
    LEA BX, s1
    JMP display
speed2:
    LEA BX, s2
    JMP display
speed3:
    LEA BX, s3
    JMP display
speed4:
    LEA BX, s4
    JMP display
speed5:
    LEA BX, s5
    JMP display
speed6:
    LEA BX, s6
    JMP display
speed7:
    LEA BX, s7
    JMP display
speed8:
    LEA BX, s8
    JMP display
 
display: 
    CALL LED_DISP
    JMP LOP 

;***********************뿪жϷ *******************
INT_PROC PROC FAR
	PUSH AX
	PUSH CX
	MOV DX,I8255_B
	IN AL,DX;뿪صƽź
	CMP AL,10000000B;ΪA/Dת˳ж
	JAE over1
;֧뿪תƥ 
	CMP AL,00000000B
	JA next1
	MOV speed,1
	LEA BX,s8
	JMP over
next1:
	CMP AL,00000001B
	JA next2
	MOV speed,2
	LEA BX,s7 
	JMP over
next2:
	CMP AL,00000011B
	JA next3
	MOV speed,3
	LEA BX,s6
	JMP over
next3:
	CMP AL,00000111B
	JA next4
	MOV speed,4
	LEA BX,s5
	JMP over
next4:
	CMP AL,00001111B
	JA next5
	MOV speed,5
	LEA BX,s4
	JMP over
next5:
	CMP AL,00011111B
	JA next6
	MOV speed,6
	LEA BX,s3
	JMP over
next6:
	CMP AL,00111111B
	JA next7
	MOV speed,7
	LEA BX,s2
	JMP over
next7:
	MOV speed,8
	LEA BX,s1
over:
	MOV DX,I8254_1 ;ͨ8254ʱ2ģʽ3ռձȲͬĲδӶת
	MOV AX,speed
	OUT DX,AL
	XCHG AL,AH
	OUT DX,AL
over1:	
	MOV AL,20h;жϽ  
	MOV DX,I8259_0
	OUT DX,AL
	POP CX
	POP AX
	STI 
	MOV DX,I0809_CS 
	OUT DX,AL;ٴA/Dת 
	IRET
INT_PROC ENDP
;***************A/DתжϷ*****************
INT_PROC1 PROC FAR
	PUSH AX
	PUSH CX
	MOV DX,I8255_B
	IN AL,DX;뿪صƽź
	CMP AL,10000000B
	JNE over3;Ϊ뿪ع״̬˳ж
	
	MOV DX,I0809_CS + 1
	IN AL,DX;תֵ	
;·֧һϵеֵֵͬA/DתȽϣƥӦĵת
	call disp
	CMP AL,40
	JNC n1
	MOV speed,1
	LEA BX,s8
	JMP over2
n1:
	CMP AL,70
	JNC n2
	MOV speed,2
	LEA BX,s7
	JMP over2
n2:
	CMP AL,100
	JNC n3
	MOV speed,3
	LEA BX,s6
	JMP over2
n3:	
	CMP AL,130
	JNC n4
	MOV speed,4
	LEA BX,s5
	JMP over2
n4:	
	CMP AL,160
	JNC n5
	MOV speed,5
	LEA BX,s4
	JMP over2
n5:	
	CMP AL,190
	JNC n6
	MOV speed,6
	LEA BX,s3
	JMP over2
n6:	
	CMP AL,220
	JNC n7
	MOV speed,7
	LEA BX,s2
	JMP over2
n7:	
	MOV speed,8
	LEA BX,s1

over2:	
	MOV DX,I8254_1
	MOV AX,speed;
	OUT DX,AL
	XCHG AL,AH
	OUT DX,AL
;жspeedСǷ񳬹ֵ
	MOV DX,I8255_C
	CMP speed,2
	JB BBB
	MOV AL,00h
	JMP CCC
BBB:
	MOV AL,01h
CCC:
	OUT DX,AL
over3: 	
	MOV AL,20H
	MOV DX,I8259_0
	OUT DX,AL
	POP CX
	POP AX
	STI
	MOV DX,I0809_CS 
	OUT DX,AL
	IRET
INT_PROC1 ENDP
;****************LEDʾӳ *********************
LED_DISP PROC
	MOV AL,[BX]
	MOV DX,I8255_A
	OUT DX,AL
	RET
LED_DISP ENDP


;*****************ʾӳ***********************
disp proc
    push    bx
    push    dx
    push    ax
    push    cx
    mov     si,offset  ledcode
    mov     bx,si
    mov     ch,al
    cmp     led1,01h;жλ
    jne     led2
    mov     cl,4        ;λ
    ror     al,cl
    and     al,0fh     	                       
    mov     ah,0		
    add     bx,ax
    mov     al,[bx]
    mov     dx,led_io	;λдܽӿ
    out     dx,al
    mov     al,02h		;ѡͨ2
    inc     dx
    nop
    out     dx,al
    call    delay 		;ʱ
    mov     led1,0
    jmp     kkk
    
led2:                   ;λ
    mov     al,ch
    and     al,0fh
    mov     ah,0
    add     si,ax
    mov     al,[si]
    mov     dx,led_io
    out     dx,al
    mov     al,01h
    Inc     dx
    out     dx,al
    call    delay		;ʱ
    mov     led1,01h 
kkk:
    pop    cx
    pop     ax
    pop     dx
    pop     bx
    ret
disp  endp  

delay	proc
	push cx
	mov cx,50h
x1:
	loop x1
	pop cx
	ret
delay 	endp
CODE ENDS
END START
